<?php
/**
 * 
 * 
 * @author superbaillot
 * 
 * Copyright 2012-2013 Superbaillot
 * This file is part of Aeres.
 *
 *  Aeres is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Aeres is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 */
class FiltreRecherche
{
	private $text = "";
	private $listeEtat;
	private $caseSensitive=false;
	private $tousLesMots=false;
	private $tag=false;

	public function getText()
	{
		if($this->getCaseSensitive())
		{
			return $this->text;
		}
		else
		{
			return strtolower($this->text);
		}
	}
	public function setText($text)
	{
		if(trim($text) == "")
		{
			throw new Exception($GLOBALS["langue"]->get("EXCEPTION_RECHERCHE_TITRE"));
		}
		else
		{
			$this->text = trim($text);
		}
	}

	public function getListeEtat(){return $this->listeEtat;}
	public function setListeEtat($listeEtat){$this->listeEtat = $listeEtat;}

	public function addEtat($etat)
	{
		if(!in_array($etat, $this->listeEtat))
		{
			$this->listeEtat[] = $etat;
		}
	}

	public function getCaseSensitive(){return $this->caseSensitive;}
	public function setCaseSensitive($caseSensitive){$this->caseSensitive = $caseSensitive;}

	public function getTousLesMots(){return $this->tousLesMots;}
	public function setTousLesMots($tousLesMots){$this->tousLesMots = $tousLesMots;}

	
	public function getTag(){return $this->tag;}
	public function setTag($tag){$this->tag = $tag;}

	/**
	 * fonction qui sauvegarde la catégorie dans un fichier
	 */
	public function __construct()
	{
		$this->listeEtat = array(RSS_NON_LU, RSS_ARCHIVE);
	}


	/**
	 * fonction qui vérifie si le formulaire a été envoyé et met à jour l'objet en conséquence
	 */
	public function checkFormulaire()
	{
		if(isset($_POST["chkbxSupp"]) && $_POST["chkbxSupp"] == "true")
		{
			$this->addEtat(RSS_LU);
		}
		if(isset($_POST["chkbxCase"]) && $_POST["chkbxCase"] == "true")
		{
			$this->setCaseSensitive(true);
		}
		if(isset($_POST["chkbxAll"]) && $_POST["chkbxAll"] == "true")
		{
			$this->setTousLesMots(true);
		}
		if(isset($_POST["chkbxTag"]) && $_POST["chkbxTag"] == "true")
		{
			$this->setTag(true);
		}
	}


//	public static function getElementFormulaire()
//	{
//		$divFiltre = new BaliseHTML("div");
//		$divFiltre->addElement(new BaliseInputCheckbox($GLOBALS["langue"]->get("RECHERCHE_SUPP"), "chkbxSupp"))
//			->addBR()
//			->addElement(new BaliseInputCheckbox($GLOBALS["langue"]->get("RECHERCHE_ALL_WORDS"), "chkbxAll", "", true))
//			->addBR()
//			->addElement(new BaliseInputCheckbox($GLOBALS["langue"]->get("RECHERCHE_CASSE"), "chkbxCase"))
//			->addBR()
//			->addElement(new BaliseInputCheckbox($GLOBALS["langue"]->get("RECHERCHE_TAG"), "chkbxTag"));
//
//		return $divFiltre;
//	}
}
?>
