<?php
/**
 *
 *
 *
 * Copyright 2012-2013 Superbaillot
 * This file is part of Aeres.
 *
 *  Aeres is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Aeres is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 */
class Rss
{
	private $id = 0;
	private $idCat = 0;
	private $etat = 0;
	private $position = 0;
	private $prive = false;
	private $favicon = "";

	private $title = "";
	private $link = "";
	private $urlFlux = "";
	private $description = "";
	private $webMaster = "";
	private $pubDate = "";
	private $dateDerniereMaj = "";
	private $frequenceMaj = "";		// frequence de maj min en minute

	private $listeImage = array();
	private $listeItem = array();


	public function getId(){return $this->id;}
	public function setId($id){$this->id = $id;}

	public function getIdCa(){return $this->idCat;}
	public function setIdCa($idCat){$this->idCat = $idCat;}

	public function getEtat(){return $this->etat;}
	public function setEtat($etat){$this->etat = $etat;}

	public function getPosition(){return $this->position;}
	public function setPosition($position){$this->position = $position;}
	
	public function getPrive(){return $this->prive;}
	public function setPrive($prive){$this->prive = $prive;}

	public function getUrlFlux(){return $this->urlFlux;}
	public function setUrlFlux($urlFlux){$this->urlFlux = trim($urlFlux);}

	public function getTitle(){return $this->title;}
	public function setTitle($title){trim($this->title = $title);}

	public function getLink(){return  $this->link;}
	public function setLink($link){
		$link = trim($link);
		if(substr($link, 0, 4) != "http")
		{
			$link = "";			
		}
		$this->link = $link;
	}

	public function getDescription(){return  $this->description;}
	public function setDescription($description){ $this->description = trim($description);}

	public function getWebMaster(){return  $this->webMaster;}
	public function setWebMaster($webMaster){ $this->webMaster = trim($webMaster);}

	public function getPubDate(){return  $this->pubDate;}
	public function setPubDate($pubDate){ $this->pubDate = $pubDate;}

	public function getFavicon(){return  $this->favicon;}
	public function setFavicon($favicon){ $this->favicon = $favicon;}
	
	public function getListeImage(){return $this->listeImage;}
	public function setListeImage($listeImage){$this->listeImage = $listeImage;}

	public function getListeItem(){return $this->listeItem;}
	public function setListeItem($listeItem){$this->listeItem = $listeItem;}

	public function getDateDerniereMaj(){return $this->dateDerniereMaj;}
	public function setDateDerniereMaj($dateDerniereMaj){$this->dateDerniereMaj = $dateDerniereMaj;}

	public function getFequenceMaj(){return $this->frequenceMaj;}
	public function setFequenceMaj($requenceMaj){$this->frequenceMaj = $requenceMaj;}
	/**
	 * fonction qui ajoute le flux dans la liste s'il n'y est pas encore et enregistre le fichiers correspondant
	 */
	public function enregistrer()
	{
		//on s'assure que l'on a charger la liste des flux
		chargerListeFlux();

		//si l'id vaut 0, on doit faire un ajout
		if($this->getId() == 0)
		{
			$pos = 1;
			$liste = getListeRss($this->idCat);
			if(count($liste)>0)
			{
				usort($GLOBALS["listeFluxRss"][$this->idCat], "triFluxParPosition");
				$g = $GLOBALS["listeFluxRss"][$this->idCat];
				$ind = count($g)-1;
				$temp = $g[$ind];

				$pos = $temp->getPosition() +1;
			}
			$this->setPosition($pos);
			$this->setId(getIdSuivant($GLOBALS['arrayIdFlux']));

			$GLOBALS["listeFluxRss"][$this->idCat][] = $this;
		}
		$this->ecrireFichierRss();
	}


	/**
	 * fonction qui sauvegarde l'objet dans un fichier xml
	 */
	public function ecrireFichierRss()
	{
		if($this->getId()>0)
		{
			$fichier = @fopen(NOM_FICHIER_FLUX . $this->getId() . ".xml", 'w+');
			@fwrite($fichier, $this->getXML());
			@fclose($fichier);
		}
	}


	/**
	 * méthode qui construit la version XML du flux RSS
	 * @return String : code XML
	 */
	public function getXML()
	{
		$xml = new DOMDocument("1.0", "UTF-8");
		$xml->formatOutput = true;	//pour une indentation correcte (pas sur une seule ligne)
			
		$rss = $xml->createElement("rss");
		$xml->appendChild($rss);
		$channel = $xml->createElement("channel");
		$rss->appendChild($channel);
		
		$channel->appendChild(getDomElement($xml, "id", $this->getId()));
		$channel->appendChild(getDomElement($xml, "idCat", $this->getIdCa()));
		$channel->appendChild(getDomElement($xml, "urlFlux", $this->getUrlFlux(), true));
		$channel->appendChild(getDomElement($xml, "title", $this->getTitle(), true));
		$channel->appendChild(getDomElement($xml, "position", $this->getPosition()));
		$channel->appendChild(getDomElement($xml, "prive", ($this->getPrive() ? "true" : "false")));
		$channel->appendChild(getDomElement($xml, "etat", $this->getEtat()));
		$channel->appendChild(getDomElement($xml, "favicon", $this->getFavicon(), true));
		$channel->appendChild(getDomElement($xml, "description", $this->getDescription(), true));
		$channel->appendChild(getDomElement($xml, "link", $this->getLink(), true));
		$channel->appendChild(getDomElement($xml, "pubDate", $this->getLink(), true));
		$channel->appendChild(getDomElement($xml, "webMaster", $this->getWebMaster(), true));
		$channel->appendChild(getDomElement($xml, "dateDerniereMaj", $this->getDateDerniereMaj(), true));
		$channel->appendChild(getDomElement($xml, "fequenceMaj", $this->getFequenceMaj(), true));
		
		
		if(count($this->getListeImage()) > 0)
		{
			foreach($this->getListeImage() as $img)
			{
				if($img['url'] != "")
				{
					$xmlImg = $xml->createElement("image");
					$channel->appendChild($xmlImg);
					$xmlImg->appendChild(getDomElement($xml, "url", $img['url'], true));
					if($img['title'] != "")
					{
						$xmlImg->appendChild(getDomElement($xml, "title", $img['title'], true));
					}
					if($img['link'] != "")
					{
						$xmlImg->appendChild(getDomElement($xml, "link", $img['link'], true));
					}
				}
			}
		}
		
		if(count($this->getListeItem()) > 0)
		{	
			foreach($this->getListeItem() as $item)
			{
				$channel->appendChild($item->toXML($xml));
			}
		}
			
		return $xml->saveXML();
	}


	/**
	 * fonction qui supprime un flux. Supprime de la liste, suppression du fichier xml et du favicon
	 */
	public function supprimer()
	{
		//on met à jour les positions
		decalerFlux($this->idCat, $this->position);

		//on supprime le favicon s'il existe
		if($this->getFavicon() != "" && file_exists(CHEMIN_FAVICON . $this->getFavicon()))
		{
			$fichier = unlink(CHEMIN_FAVICON . $this->getFavicon());
		}
		
		//on supprime l'objet de la liste
		unset($GLOBALS["listeFluxRss"][$this->idCat][$this->position]);

		//on supprime le fichier xml
		if(file_exists(NOM_FICHIER_FLUX . $this->getId() . ".xml"))
		{
			$fichier = unlink(NOM_FICHIER_FLUX . $this->getId() . ".xml");
		}
	}


	/**
	 * fonction qui va actualiser un flux. On va donc chercher s'il y a des nouveaux items.
	 * @param $xmlStr				String	: fichier xml
	 * @param $actualiseFavicon		boolean	: récupérer le favicon peut prendre du temps (il faut charger une page, 1 appel, parser la page pour trouver si un favicon est défini, si on en trouve un, il faut aller le chercher, second appel server)
	 * @param $antiIframe			boolean	: défini s'il laisser les iframes ou les supprimer pour éviter les éventuels hack
	 */
	public function actualiser($xmlStr, $actualiseFavicon, $antiIframe=true)
	{
		$this->parse(trim($xmlStr), false, $actualiseFavicon, $antiIframe);
		
		$this->ecrireFichierRss();
	}


	/**
	 * fonction qui va charger l'objet avec les données contenu dans le fichier xml si on connait son id
	 * @param $fichier	String
	 */
	public function charger()
	{
		if($this->id > 0)
		{
			if(file_exists(NOM_FICHIER_FLUX . $this->id . ".xml"))
			{
				$this->chargerFichier(NOM_FICHIER_FLUX . $this->id . ".xml");
			}
			else
			{
				$this->id = 0;
			}
		}
	}


	/**
	 * fonction qui va charger l'objet avec les données contenu dans le fichier xml
	 * @param $fichier	String : chemin du fichier
	 */
	public function chargerFichier($fichier)
	{
		if(file_exists($fichier))
		{
			$xmlStr = file_get_contents($fichier);
			$this->parse($xmlStr);
		}
	}
	
	/**
	 * Fonction qui définie si on peut actualiser le flux en fonction de sa dernière mise à jour et de sa fréquence de racfraichissement
	 */
	public function peutActualiser()
	{
		global $config;
		
		$frequence = $this->getFequenceMaj();
		if(!empty($frequence))
		{
			$dateMaj = $this->getDateDerniereMaj();
			
			if(empty($dateMaj))
			{
				$dateMaj = date("Y-m-d H:i:s");
			}
			$now = strtotime(date("Y-m-d H:i:s"));
			$datetime = strtotime($dateMaj);
			return $datetime <= $now - ($frequence*60);
		}
		return true;
	}


	/**
	 * fonction qui va charger l'objet avec les données contenu dans le fichier xml
	 * @param $xmlStr				String	: fichier xml
	 * @param $chargeFichier		boolean	: vrai si on charge un fichier sauvegardé, faux lors d'une actualisation
	 * @param $actualiserFavicon	boolean	: défini s'il faut aussi actualier le favicon
	 * @param $antiIframe			boolean	: défini s'il laisser les iframes ou les supprimer pour éviter les éventuels hack
	 */
	private function parse($xmlStr, $chargeFichier=true, $actualiserFavicon=false, $antiIframe=true)
	{
		$nb =0;
		$xmlLocal = new DOMDocument();
			
		if(@$xmlLocal->loadXML($xmlStr))
		{
			if($chargeFichier)
			{
				$temp = $xmlLocal->getElementsByTagName('channel')->item(0);
				$this->setId($temp->getElementsByTagName('id')->item(0)->nodeValue);
				$this->setIdCa($temp->getElementsByTagName('idCat')->item(0)->nodeValue);
				$this->setUrlFlux($temp->getElementsByTagName('urlFlux')->item(0)->nodeValue);
				$this->setEtat($temp->getElementsByTagName('etat')->item(0)->nodeValue);
				$this->setPosition($temp->getElementsByTagName('position')->item(0)->nodeValue);
				$this->setDateDerniereMaj($temp->getElementsByTagName('dateDerniereMaj')->item(0)->nodeValue);
				$this->setFequenceMaj($temp->getElementsByTagName('fequenceMaj')->item(0)->nodeValue);

				if($temp->getElementsByTagName('favicon')->length>0)
				{
					$this->setFavicon($temp->getElementsByTagName('favicon')->item(0)->nodeValue);
				}

				if($temp->getElementsByTagName('prive')->length>0)
				{
					if($temp->getElementsByTagName('prive')->item(0)->nodeValue == "true")
					{
						$this->setPrive(true);
					}
					else
					{
						$this->setPrive(false);
					}
				}
			
				//il est inutile de passer par la fonction antiHack car elle a déjà été passée lors de l'actualisation du flux
				$this->setTitle(Rss::getChanelTitle($xmlLocal));
				$this->setLink(Rss::getChanelLink($xmlLocal));
				$this->setDescription(Rss::getChanelDescription($xmlLocal));
				$this->setPubDate(Rss::getChanelDate($xmlLocal));
				$this->setListeImage(Rss::getChanelImage($xmlLocal));
			}
			else
			{
				$this->setTitle(antiHack(Rss::getChanelTitle($xmlLocal)));
				$this->setLink(antiHack(Rss::getChanelLink($xmlLocal)));
				$this->setDescription(antiHack(Rss::getChanelDescription($xmlLocal)));
				$this->setPubDate(antiHack(Rss::getChanelDate($xmlLocal)));
				$this->setListeImage(Rss::getChanelImage($xmlLocal));

				$this->setDateDerniereMaj(date("Y-m-d H:i:s"));
			}
			$liste = array();
			foreach(Rss::getListeItems($xmlLocal) as $xmlItem)
			{
				if($chargeFichier)
				{
					$item = new RssItem();

					$item->setId($xmlItem->getElementsByTagName('id')->item(0)->nodeValue);
					$item->setEtat($xmlItem->getElementsByTagName('etat')->item(0)->nodeValue);
					$item->setIdFlux($this->getId());
					$item->setDescription(Rss::getItemDescription($xmlItem));
					$item->setPubDate(Rss::getItemDate($xmlItem));
					//pour les sauvegarde qui n'ont pas de dateAffichee, je prends la date de publication
					if($xmlItem->getElementsByTagName('dateAffichee')->length>0 && $xmlItem->getElementsByTagName('dateAffichee')->item(0)->nodeValue != "")
					{
						$item->setDateAffichee($xmlItem->getElementsByTagName('dateAffichee')->item(0)->nodeValue);
					}
					else
					{
						$item->setDateAffichee($item->getPubDate());
					}

					//on repère les id déjà utilisés dans 'arrayIdItem' pour pouvoir facilement récupérer l'id suivant
					utiliseIdItem($item->getId());

					//il est inutile de passer par la fonction antiHack car elle a déjà été passée lors de l'actualisation du flux
					$item->setTitle(Rss::getItemTitle($xmlItem));
					$item->setLink(Rss::getItemLink($xmlItem));
					$item->setGuid(Rss::getItemId($xmlItem));
					$item->setAuthor(Rss::getItemAuthor($xmlItem));
					$item->setListeEnclosure(Rss::getItemEnclosure($xmlItem));
					$item->setListeCategorie(Rss::getItemCategory($xmlItem));

					$liste[] = $item;
				}
				else
				{
					//je considère que, par défaut, l'item existe et il faut donc le mettre à jour (c'est le cas pour la plupart des items lors d'une mise à jour)
					$maj = true;
					$item = $this->estDansListe($xmlItem);

					//si l'item n'existe pas ,il faut l'ajouter et non le mettre à jour. Il y a donc des champs à remplir uniquement dans ce cas
					if($item === false)
					{
						$maj = false;
						$item = new RssItem();
							
						//les champs ci-dessou ne doivent pas être mis à jour (id et etat : évident ; le reste sert à définir l'unicité d'un item)
						$item->setId(getIdItemSuivant());
						$item->setIdFlux($this->getId());
						$item->setEtat(RSS_NON_LU);
						$item->setGuid(antiHack(Rss::getItemId($xmlItem)));
					}

					//les champs ci-dessou peuvent être mis à jour
					$item->setTitle(antiHack(Rss::getItemTitle($xmlItem)));
						
					$desc = Rss::getItemDescription($xmlItem);
					//transformation des liens relatifs en absolus
					$desc = verifierLienRelatif($desc, $this->getLink(), "href");
					$desc = verifierLienRelatif($desc, $this->getLink(), "src");
					$desc = antiHack($desc, $antiIframe);
					$item->setDescription($desc);
					
					$item->setLink(antiHack(Rss::getItemLink($xmlItem)));
					$item->setAuthor(antiHack(Rss::getItemAuthor($xmlItem)));
					$item->setListeEnclosure(Rss::getItemEnclosure($xmlItem));
					$item->setListeCategorie(Rss::getItemCategory($xmlItem));
					$date = Rss::getItemDate($xmlItem);
					if($date == "")
					{
						if($item->getDateAffichee() == "")
						{
							$item->setPubDate($date);
							$item->setDateAffichee(date("Y-m-d H:i:s"));
						}
					}
					else
					{
						$item->setPubDate(date("Y-m-d H:i:s",strtotime($date)));
						$item->setDateAffichee(date("Y-m-d H:i:s",strtotime($date)));
					}

					//si on n'est pas en mise à jour d'un item, il faut l'ajouter à la liste
					if(!$maj)
					{
						$this->listeItem[] = $item;

						//on incrémente le compteur de nouveaux items du flux
						$nb++;
					}
				}
			}

			if($chargeFichier)
			{
				$this->setListeItem($liste);
			}
			else
			{	
				$this->setEtat(ACCESSIBLE);
				if($actualiserFavicon)
				{
					$this->setFavicon(getFaviconRss($this));
				}
				//si on a des nouveau items, il y de forte chance que certains aient disparus.
				//on va donc les supprimer pour ne pas avoir des fichiers de plus en plus gros
				if($nb>0)
				{
					//pour chaque item enregistrer, on vérifie s'il faut le supprimer
					foreach($this->listeItem as $item)
					{
						//on supprime un item uniquement s'il a déjà été lu et s'il n'est plus dans le nouveau flux
						if($item->getEtat() == RSS_LU && !Rss::estDansFluxXml(Rss::getListeItems($xmlLocal), $item))
						{
							unset($this->listeItem[array_search($item, $this->listeItem)]);
						}
					}
				}
			}	
		}
		else
		{
			$this->setEtat(RSS_NON_ACCESSIBLE);
		}
	}


	/**
	 * fonction qui va chercher le nombre d'item archivé d'un flux
	 * @return int : nombre d'item archivés
	 */
	public function nbItemArchive($nonLu=true, $archive=false)
	{
		$etat = array();
		if($nonLu)
		{
			$etat[] = RSS_NON_LU;
		}
		if($archive)
		{
			$etat[] = RSS_ARCHIVE;
		}

		$cpt = 0;
		//on parcour tous les items du flux
		foreach($this->listeItem as $item)
		{
			if(in_array($item->getEtat(), $etat))
			{
				$cpt++;
			}
		}

		return $cpt;
	}


	/**
	 * fonction qui va retourné l'item dont on connait l'id
	 * @param $id	int	: id de l'item
	 * @return RssItem
	 */
	public function getItemById($id)
	{
		foreach ($this->listeItem as &$item)
		{
			if($item->getId() == $id)
			{
				return $item;
			}
		}
		return new RssItem();
	}


	/**
	 * fonction qui va retourné la liste d'item dont on connait les états
	 * @param $listeEtat	array()	: liste d'états
	 * @return array( RssItem )
	 */
	public function getListeItemByEtat($listeEtat)
	{
		$liste = array();
		foreach($this->listeItem as &$item)
		{
			if(in_array($item->getEtat(), $listeEtat))
			{
				$liste[] = &$item;
			}
		}
		return $liste;
	}


	/**
	 * fonction qui va récupérer la liste des éléments d'un flux RSS ou atom
	 * @param $xml	DOMDocument
	 * @return array(DOMDocument)
	 */
	static function getListeItems($xml)
	{
		//flux RSS
		if($xml->getElementsByTagName('channel')->length>0)
		{
			return $xml->getElementsByTagName('item');
		}
		//flux atom
		elseif($xml->getElementsByTagName('entry')->length>0)
		{
			return $xml->getElementsByTagName('entry');
		}
		else
		{
			return array();
		}
	}


	/**
	 * fonction qui va chercher le lien d'un élément dans un flux RSS ou atom
	 * @param $item		DOMDocument
	 * @return String
	 */
	static function getItemLink($item)
	{
		if($item->getElementsByTagName('link')->length>0)
		{
			$lien = $item->getElementsByTagName('link')->item(0);
			//flux atom
			if($lien->hasAttributes())
			{
				return trim($lien->attributes->getNamedItem("href")->nodeValue);
			}
			//flux RSS
			else
			{
				return trim($lien->nodeValue);
			}
		}
		else
		{
			return "";
		}
	}


	/**
	 * fonction qui va chercher la date de publication d'un élément dans un flux RSS ou atom
	 * @param $item		DOMDocument
	 * @return String
	 */
	static function getItemDate($item)
	{
		//flux RSS
		if($item->getElementsByTagName('pubDate')->length>0)
		{
			return trim($item->getElementsByTagName('pubDate')->item(0)->nodeValue);
		}
		//flux atom
		elseif($item->getElementsByTagName('published')->length>0)
		{
			return trim($item->getElementsByTagName('published')->item(0)->nodeValue);
		}
		//flux atom
		elseif($item->getElementsByTagName('updated')->length>0)
		{
			return trim($item->getElementsByTagName('updated')->item(0)->nodeValue);
		}
		//flux atom
		elseif($item->getElementsByTagName('date')->length>0)
		{
			return trim($item->getElementsByTagName('date')->item(0)->nodeValue);
		}
		else
		{
			return "";
		}
	}


	/**
	 * fonction qui va chercher la desctiption d'un élément dans un flux RSS ou atom
	 * @param $item		DOMDocument
	 * @return String
	 */
	static function getItemDescription($item)
	{
		//flux RSS
		if($item->getElementsByTagName('encoded')->length>0)
		{
			return trim($item->getElementsByTagName('encoded')->item(0)->nodeValue);
		}
		elseif($item->getElementsByTagName('description')->length>0)
		{
			return trim($item->getElementsByTagName('description')->item(0)->nodeValue);
		}
		//flux atom
		if($item->getElementsByTagName('content')->length>0)
		{
			return trim($item->getElementsByTagName('content')->item(0)->nodeValue);
		}
		//flux atom 2
		if($item->getElementsByTagName('summary')->length>0)
		{
			return trim($item->getElementsByTagName('summary')->item(0)->nodeValue);
		}
		else
		{
			return "";
		}
	}


	/**
	 * fonction qui va chercher le titre d'un élément dans un flux RSS ou atom
	 * @param $item		DOMDocument
	 * @return String
	 */
	static function getItemTitle($item)
	{
		//flux RSS et atom
		if($item->getElementsByTagName('title')->length>0)
		{
			return trim($item->getElementsByTagName('title')->item(0)->nodeValue);
		}
		else
		{
			return "";
		}
	}


	/**
	 * fonction qui va chercher l'auteur d'un élément dans un flux RSS ou atom
	 * @param $item		DOMDocument
	 * @return String
	 */
	static function getItemAuthor($item)
	{
		//flux RSS et atom
		if($item->getElementsByTagName('author')->length>0)
		{
			$author = $item->getElementsByTagName('author')->item(0);
			//atom
			if($author->getElementsByTagName('name')->length>0)
			{
				return trim($author->getElementsByTagName('name')->item(0)->nodeValue);
			}
			//RSS
			else
			{
				return trim($item->getElementsByTagName('author')->item(0)->nodeValue);
			}
		}
		elseif($item->getElementsByTagName('creator')->length>0)
		{
			return trim($item->getElementsByTagName('creator')->item(0)->nodeValue);
		}
		else
		{
			return "";
		}
	}


	/**
	 * fonction qui va chercher l'identifiant unique d'un élément dans un flux RSS ou atom
	 * @param $item		DOMDocument
	 * @return String
	 */
	static function getItemId($item)
	{
		//flux RSS
		if($item->getElementsByTagName('guid')->length>0)
		{
			return trim($item->getElementsByTagName('guid')->item(0)->nodeValue);
		}//flux atom
		elseif($item->getElementsByTagName('id')->length>0)
		{
			return trim($item->getElementsByTagName('id')->item(0)->nodeValue);
		}
		else
		{
			return "";
		}
	}


	/**
	 * fonction qui va chercher si un(des) média est attaché à l'item
	 * @param $item		DOMDocument
	 * @return array
	 */
	static function getItemEnclosure($item)
	{
		$liste = array();
		
		//flux RSS
		if($item->getElementsByTagName('enclosure')->length>0)
		{
			foreach ($item->getElementsByTagName('enclosure') as $link)
			{
				$enclosure = array();
				if(!is_null($link->attributes->getNamedItem("url")))
				{
					$enclosure['url'] = trim($link->attributes->getNamedItem("url")->nodeValue);
					if(!is_null($link->attributes->getNamedItem("type")))
					{
						$enclosure['type'] = trim($link->attributes->getNamedItem("type")->nodeValue);
					}
					if(!is_null($link->attributes->getNamedItem("length")))
					{
						$enclosure['length'] = trim($link->attributes->getNamedItem("length")->nodeValue);
					}
					$liste[] = $enclosure;
				}
			}
		}
		
		//rss'
		elseif($item->getElementsByTagName('content')->length>0)
		{
			foreach ($item->getElementsByTagName('content') as $media)
			{
				$enclosure = array();
				if(!is_null($media->attributes->getNamedItem("url")))
				{
					$enclosure['url'] = trim($media->attributes->getNamedItem("url")->nodeValue);
					if(!is_null($media->attributes->getNamedItem("medium")))
					{
						$enclosure['type'] = trim($media->attributes->getNamedItem("medium")->nodeValue);
					}
					if(!is_null($media->attributes->getNamedItem("length")))
					{
						$enclosure['length'] = trim($media->attributes->getNamedItem("length")->nodeValue);
					}
					$liste[] = $enclosure;
				}
			}
		}
		
		//atom
		elseif($item->getElementsByTagName('link')->length>0)
		{
			foreach ($item->getElementsByTagName('link') as $link)
			{
				$enclosure = array();
				if(!is_null($link->attributes->getNamedItem("rel")) && $link->attributes->getNamedItem("rel")->nodeValue == "enclosure")
				{
					if(!is_null($link->attributes->getNamedItem("url")))
					{
						$enclosure['url'] = trim($link->attributes->getNamedItem("url")->nodeValue);
						if(!is_null($link->attributes->getNamedItem("type")))
						{
							$enclosure['type'] = trim($link->attributes->getNamedItem("type")->nodeValue);
						}
						if(!is_null($link->attributes->getNamedItem("length")))
						{
							$enclosure['length'] = trim($link->attributes->getNamedItem("length")->nodeValue);
						}
						$liste[] = $enclosure;
					}
				}
			}
		}
		
		return $liste;
	}
	
	
	/**
	 * fonction qui va chercher si un(des) catérogies est attachée à l'item
	 * @param $item		DOMDocument
	 * @return array
	 */
	function getItemCategory($item)
	{
		$liste = array();
		
		if($item->getElementsByTagName('category')->length>0)
		{
			foreach ($item->getElementsByTagName('category') as $cat)
			{
				//atom
				if(!is_null($cat->attributes->getNamedItem("term")))
				{
					$liste[] = trim($cat->attributes->getNamedItem("term")->nodeValue);
				}
				//RSS
				elseif($cat->nodeValue != "")
				{
					$liste[] = trim($cat->nodeValue);
				}
			}
		}
		
		elseif($item->getElementsByTagName('subject')->length>0)
		{
			foreach ($item->getElementsByTagName('subject') as $cat)
			{
				//atom
				if($cat->nodeValue != "")
				{
					$liste[] = trim($cat->nodeValue);
				}
			}
		}
		
		return $liste;
	}


	/**
	 * fonction qui va chercher le lien d'un flux RSS ou atom
	 * @param $item		DOMDocument
	 * @return String
	 */
	static function getChanelLink(DOMDocument $xml)
	{
		//flux RSS
		if($xml->getElementsByTagName('channel')->length>0)
		{
			if($xml->getElementsByTagName('channel')->item(0)->getElementsByTagName('link')->length>0)
			{
				foreach($xml->getElementsByTagName('channel')->item(0)->getElementsByTagName('link') as $it)
				{
					if($it->nodeValue != "")
					{
						return trim($it->nodeValue);
					}
				}
			}
		}
		//flux atom
		elseif($xml->getElementsByTagName('link')->length>0)
		{
			//flux atom
			if($xml->getElementsByTagName('link')->length>0)
			{
				return trim($xml->getElementsByTagName('link')->item(0)->attributes->getNamedItem("href")->nodeValue);
			}
		}
		else
		{
			return "";
		}
	}


	/**
	 * fonction qui va chercher le titre d'un flux RSS ou atom
	 * @param $item		DOMDocument
	 * @return String
	 */
	static function getChanelTitle(DOMDocument $xml)
	{
		//flux RSS
		if($xml->getElementsByTagName('channel')->length>0)
		{
			if($xml->getElementsByTagName('channel')->item(0)->getElementsByTagName('title')->length>0)
			{
				foreach($xml->getElementsByTagName('channel')->item(0)->getElementsByTagName('title') as $it)
				{
					if($it->nodeValue != "")
					{
						return trim($it->nodeValue);
					}
				}
			}
		}
		//flux atom
		elseif($xml->getElementsByTagName('title')->length>0)
		{
			return trim($xml->getElementsByTagName('title')->item(0)->nodeValue);
		}
		else
		{
			return "";
		}
	}


	/**
	 * fonction qui va chercher la description d'un flux RSS ou atom
	 * @param $item		DOMDocument
	 * @return String
	 */
	static function getChanelDescription(DOMDocument $xml)
	{
		//flux RSS
		if($xml->getElementsByTagName('channel')->length>0)
		{
			$desc = $xml->getElementsByTagName('channel')->item(0)->getElementsByTagName('description');
			
			//je ne prends la description que si on est pas dans un item
			if($desc->length>0 && strpos($desc->item(0)->getNodePath(), "item") === false)
			{
				return trim($desc->item(0)->nodeValue);
			}
		}
		//flux atom
		elseif($xml->getElementsByTagName('subtitle')->length>0)
		{
			return trim($xml->getElementsByTagName('subtitle')->item(0)->nodeValue);
		}
	}


	/**
	 * fonction qui va chercher la date de publication d'un flux RSS ou atom
	 * @param $item		DOMDocument
	 * @return String
	 */
	static function getChanelDate(DOMDocument $xml)
	{
		//flux RSS
		if($xml->getElementsByTagName('channel')->length>0)
		{
			if($xml->getElementsByTagName('channel')->item(0)->getElementsByTagName('pubDate')->length>0)
			{
				return trim($xml->getElementsByTagName('channel')->item(0)->getElementsByTagName('pubDate')->item(0)->nodeValue);
			}
		}
		//flux atom
		elseif($xml->getElementsByTagName('updated')->length>0)
		{
			return trim($xml->getElementsByTagName('updated')->item(0)->nodeValue);
		}
		else
		{
			return "";
		}
	}


	/**
	 * fonction qui va chercher l'image d'un flux RSS ou atom
	 * @param $item		DOMDocument
	 * @return array()
	 */
	static function getChanelImage(DOMDocument $xml)
	{
		$liste = array();
		
		//flux RSS	
		if($xml->getElementsByTagName('image')->length>0)
		{
			foreach ($xml->getElementsByTagName('image') as $img)
			{
				$imgArr = array();
				if($img->getElementsByTagName('url')->length>0)
				{
					$imgArr['url'] = $img->getElementsByTagName('url')->item(0)->nodeValue;
				}
				if($img->getElementsByTagName('title')->length>0)
				{
					$imgArr['title'] = $img->getElementsByTagName('title')->item(0)->nodeValue;
				}
				if($img->getElementsByTagName('link')->length>0)
				{
					$imgArr['link'] = $img->getElementsByTagName('link')->item(0)->nodeValue;
				}
				
				if(isset($imgArr['url']))
				{
					$liste[] = $imgArr;
				}
			}
		}
		
		return $liste;
	}


	/**
	 * fonction qui vérifie si le titre est déjà dans un des items de la liste
	 * @param $titre	string			: titre d'un item du flux
	 * @return boolean ou RssItem
	 */
	public function estDansListe($xmlItem)
	{
		foreach ($this->listeItem as $item)
		{
			//le guid est cencé être unique (c'est au générateur du flux de le vérifier, moi, je concidère qu'il est bien unique)
			$guidXml = antiHack(Rss::getItemId($xmlItem));
			if($guidXml != "" && $item->getGuid() == $guidXml)
			{
				return $item;
			}
			
			//si on a pas d'identifiant unique, je décide que l'identifant sera le couple (titre, date)
			elseif($guidXml == "" && ($item->getTitle() == antiHack(Rss::getItemTitle($xmlItem)) && $item->getPubDate() == date("Y-m-d H:i:s",strtotime(Rss::getItemDate($xmlItem)))))
			{
				return $item;
			}
		}
		return false;
	}


	/**
	 * fonction qui vérifie si un titre est dans la listes des flux d'un DOMDocument
	 * @param $xmlItem	DOMDocument		: liste des items du flux qui est sur le server
	 * @param $titre	String			: titre
	 * @return boolean
	 */
	static function estDansFluxXml($xmlItem, $item)
	{
		foreach($xmlItem as $it)
		{
			$guidXml = antiHack(Rss::getItemId($it));
			if($guidXml != "" && $item->getGuid() == $guidXml)
			{
				return true;
			}
			
//			if($item->getTitle() == Rss::getItemTitle($it) && $item->getPubDate() == date("Y-m-d H:i:s",strtotime(Rss::getItemDate($it))) && $item->getGuid() == Rss::getItemId($it))
			elseif($guidXml == "" && ($item->getTitle() == antiHack(Rss::getItemTitle($it)) && $item->getPubDate() == date("Y-m-d H:i:s",strtotime(Rss::getItemDate($it)))))
			{
				return true;
			}
		}
		return false;
	}
}


/**
 * fonction qui va chercher le flux dont on connait l'id
 * @param $idFlux		int	: id du flux
 * @return Rss
 */
function getFluxById($idFlux)
{
	chargerListeFlux();
	$flux = new Rss();
	if($GLOBALS['listeFluxRss'] != null)
	{
		if(count($GLOBALS['listeFluxRss']) > 0)
		{
			foreach($GLOBALS['listeFluxRss'] as &$listeCat)
			{
				if(count($listeCat) > 0)
				{
					foreach($listeCat as &$rss)
					{
						if($rss->getId() == $idFlux)
						{
							return $rss;
						}
					}
				}
			}
		}
	}
	else
	{
		$flux->setId($idFlux);
		$flux->charger();
	}
	return $flux;
}


/**
 * fonction qui va chercher dans la base le flux dont on connait l'url
 * @param $urlFlux		String	: url du flux
 * @return Rss
 */
function getFluxByUrl($urlFlux)
{
	chargerListeFlux();
	$urlFlux = trim($urlFlux);
	
	//on va parcourir tous les fichiers rss et s'arreter des qu'on trouve la meme url
	if(count($GLOBALS["listeFluxRss"]) >0)
	{
		//on parcours toutes les catégories
		foreach($GLOBALS["listeFluxRss"] as &$tabCat)
		{
			if(count($tabCat) >0)
			{
				//on parcours chaque flux de chaque catégorie
				foreach($tabCat as &$flux)
				{
					if($flux->getUrlFlux() == $urlFlux)
					{
						return $flux;
					}
				}
			}
		}
	}
	return new Rss();
}


/**
 * fonction qui renvoi le flux rss suivant (ou précédant) d'une catégorie
 * @param $rss		Rss		: flux dont on veut connaitre le suivant ou le précédant
 * @param $prec		boolean	: sert a savoir si on veut le précédant ou le suivant
 * @return Rss
 */
function getFluxSuivant(Rss $rss, $prec = false)
{
	razPosition();
	foreach($GLOBALS["listeFluxRss"][$rss->getIdCa()] as &$flux)
	{
		if((!$prec && $flux->getPosition() == ($rss->getPosition() + 1)) || ($prec && $flux->getPosition() == ($rss->getPosition() - 1)))
		{
			return $flux;
		}
	}
	return new Rss();
}


/**
 * fonction qui retourne la position suivante dans une catégorie
 * @param $idCat	int	: id de la catégorie dont on veut connaitre la position suivante
 * @return int : position suivante de la catégorie
 */
function getRssPositionSuivante($idCat)
{
	chargerListeFlux();
	if(isset($GLOBALS["listeFluxRss"][$idCat]))
	{
		return count($GLOBALS["listeFluxRss"][$idCat]) +1;
	}
	else
	{
		return 1;
	}
}


/**
 * fonction qui décale les positions des flux d'une catégorie à partir d'une certaine position
 */
function decalerFlux($idCat, $position)
{
	chargerListeFlux();

	for($i = $position; $i < count($GLOBALS["listeFluxRss"][$idCat]); $i++)
	{
		$temp = &$GLOBALS["listeFluxRss"][$idCat][$i];
		$temp->setPosition($temp->getPosition() -1);
		$temp->ecrireFichierRss();
	}
}


/**
 * fonction qui va chercher la liste des flux d'une catégorie
 * @param $idCat		int
 * @return array(Rss)
 */
function getListeRss($idCat)
{
	chargerListeFlux();
	if(count($GLOBALS["listeFluxRss"])>0 && isset($GLOBALS["listeFluxRss"][$idCat]))
	{
		return $GLOBALS["listeFluxRss"][$idCat];
	}
	else
	{
		return array();
	}
}


/**
 * fonction de tri des Flux par id
 * @param $c1	Rss
 * @param $c2	Rss
 * @return int
 */
function triFluxParId(Rss  $c1, Rss $c2)
{
	if($c1->getId() == $c2->getId())
	{
		return 0;
	}
	return ($c1->getId() < $c2->getId()) ? -1 : 1;
}


/**
 * fonction de tri des Flux par position
 * @param $c1	Rss
 * @param $c2	Rss
 * @return int
 */
function triFluxParPosition(Rss  $c1, Rss $c2)
{
	if($c1->getPosition() == $c2->getPosition())
	{
		return 0;
	}
	return ($c1->getPosition() < $c2->getPosition()) ? -1 : 1;
}


/**
 * fonction qui évite des hack un peu trop facile via des scripts
 * @param $text			String	: texte à analyser
 * @param $antiIframe	boolean	: défini s'il laisser les iframes ou les supprimer pour éviter les éventuels hack
 * @return String : $text nettoyé
 */
function antiHack($text, $antiIframe=true)
{
	//je vais supprimer les balises "script" et "iframe"
	$desc = strtolower($text);
	$posDebut = strpos($desc, "<script");
	$posFin = strpos($desc, "</script>");
	while($posDebut !== false && $posFin !== false)
	{
		$text = substr($text, 0, $posDebut) . substr($text, $posFin+9);
		$desc = strtolower($text);
		$posDebut = strpos($desc, "<script");
		$posFin = strpos($desc, "</script>");
	}
	$text = str_ireplace("<script>", "&#x3C;script&#x3E;", $text);
	if($antiIframe)
	{
		$posDebut = strpos($desc, "<iframe");
			$posFin = strpos($desc, "</iframe>");
		while($posDebut !== false && $posFin !== false)
		{
			$text = substr($text, 0, $posDebut) . substr($text, $posFin+9);
			$desc = strtolower($text);
			$posDebut = strpos($desc, "<iframe");
			$posFin = strpos($desc, "</iframe>");
		}
		$text = str_ireplace("<iframe>", "&#x3C;iframe&#x3E;", $text);
	}

	return $text;
}

function getDomElement($xml, $tag, $valeur, $cdata=false)
{
	if($cdata)
	{
		$xmlTag = $xml->createElement($tag);
		$xmlTag_Data = $xml->createCDATASection($valeur);
		$xmlTag->appendChild($xmlTag_Data);
		return $xmlTag;
	}
	else
	{
		return $xml->createElement($tag, $valeur);
	}
}
?>
