<?php
/**
 * 
 * Copyright 2012-2013 Superbaillot
 * This file is part of Aeres.
 *
 *  Aeres is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Aeres is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with Aeres.  If not, see <http://www.gnu.org/licenses/>.
 */
 ?>
<?php
	$liste = getListeRss($idCat);
	$url = "";
	
	//on affiche la liste des flux
	if(count($liste)>0)
	{
		//pour chaque flux, je vais construire un select contenant la liste des catégorie.
		//je construit une seule fois les balises "option" du select avant le foreach et je réutilise toujours la même liste
		$listeOption = "<option value='0'" . ($idCat == 0 ? " selected" : "") . ">" . $langue->get("OPTION_SANS_CATEGORIE") . "</option>\n";
	
		if(count($GLOBALS["listeCategorie"])>0)
		{
			foreach ($GLOBALS["listeCategorie"] as $categorie)
			{
				$listeOption .= "<option value='" . $categorie->getId() . "'" . ($idCat == $categorie->getId() ? " selected" : "") . ">" . $categorie->getTitre() . "</option>\n";
			}
		}
		
		//défini le nombre de flux qui seront actualisé en une requete
		$maxFluxRafraichissement = $config->getNbRafraichissement();
	
		foreach($liste as &$flux)
		{
			if($GLOBALS['connexion']->estConnecte() || !$flux->getPrive())
			{
				$cptFl++;
				
				$temp[] = $flux->getId();
				if($cptFl >= $maxFluxRafraichissement)
				{
					$cpt++;
					$script .= "				setTimeout(\"majLiClass('$url?idFlux=" . implode(",", $temp) . "', $attente, \" + time + \", " . ($config->getRafraichir() ? "true" : "false") . ")\"," . ($cpt*$decalage) . ");\n";
					
					$temp = array();
					$cptFl = 0;
				}
				
				//En effet, chez moi, si je ne fait pas le décalage, le serveur bloque au bout de 20 flux, les suivants ne sont donc pas mis à jour
?>
			<li	class="<?php echo ($idFlux_l > 0 && $idFlux_l == $flux->getId() ? " liSelected" : "liTitre"); ?>" id="li<?php echo $flux->getId()?>">
			<?php

				//on va chercher le nombre d'items non-lus et d'items archivés
				$nbNonLu = $flux->nbItemArchive();
				$nbArchive = $flux->nbItemArchive(false, true);

				//la class CSS dépend du nombre de nouveaux items
				$class = "listeTitre";
				if($flux->getEtat() == RSS_NON_ACCESSIBLE)
				{
					$class = "listeTitreNonAccessible";
				}
				elseif($nbNonLu>0 && !$edit)
				{
					$class = "listeTitreNonLu";
				}
			?>
				<div id="div<?php echo $flux->getId(); ?>" class="<?php echo $class;?>" <?php echo ($flux->getEtat() == RSS_NON_ACCESSIBLE ? "title='" . $langue->get("MSG_RECUP_FLUX_IMPOSSIBLE") . "'" : ""); ?>>
					<div class="titreFlux" <?php echo (!$edit ? "onclick=\"afficherDetail(" . $flux->getId() . ", '" . RSS_ARCHIVE . "," . RSS_NON_LU . "', 1);\"" : ""); ?>>
					<?php
						//affichage du favicon : par défaut, l'icone RSS
						$cheminImg = CHEMIN_IMAGES_FEED_VIDE;
	
						//si le flux a un favicon, on l'affiche plutot que l'icone RSS
						if($flux->getFavicon() != "" && $flux->getFavicon() != $flux->getLink())
						{
							$cheminImg = CHEMIN_FAVICON . $flux->getFavicon();
						}
					?>
						<img class="icon" src="<?php echo $cheminImg;?>" id="icon<?php echo $flux->getId();?>" alt="favicon"<?php 
									//ajoutde la possibilité de supprimer un favicon en mode d'édition
									if($edit && $flux->getFavicon() != "")
									{
										echo " onclick=\"if(confirm('" . htmlspecialchars($langue->get("CONFIRMATION_SUPPRESSION_FAVICON")) . "')){document.getElementById('suppFavicon').value='" . $flux->getId() . "'; document.getElementById('navForm').action += '#div" . $flux->getId() . "'; document.getElementById('navForm').submit();}\"";
										echo " title=\"" . htmlspecialchars($langue->get("TITLE_SUPPRIMER_FAVICON")) . "\"";
									}
								?>>
						<span class="<?php echo $flux->getPrive() ? "fluxPrive" : "fluxPublic";?>" title="<?php echo htmlspecialchars($flux->getTitle());?>">
							<?php echo $flux->getTitle();?>
						</span>
					</div>
					<?php 
						//on affiche le nombre d'éventuels items non-lus dans la version non éditable
						if(!$edit)
						{
					?>	<div class="nb">
							<span	class="archive" id="nbArchive<?php echo $flux->getId();?>" onclick="<?php echo "afficherDetail(" . $flux->getId() . ", '" . RSS_ARCHIVE . "', 1);";?>" title="<?php echo htmlspecialchars($langue->get("VOIR_ELEMENTS", $langue->get("ARCHIVE"), $flux->getTitle()));?>">
								<?php echo $nbArchive > 0 ? "$nbArchive" : ""; ?>
							</span>
							<span	class="nonLu" id="nbNonLu<?php echo $flux->getId();?>" onclick="<?php echo "afficherDetail(" . $flux->getId() . ", '" . RSS_NON_LU . "', 1);";?>" title="<?php echo htmlspecialchars($langue->get("VOIR_ELEMENTS", $langue->get("NON_LU"), $flux->getTitle()));?>">
								<?php echo $nbNonLu > 0 ? "$nbNonLu" : ""; ?>
							</span>
						</div>
						<?php
						}
						
						if($edit)
						{
						?>
						<div class="listeOtpion">
							<input name="prive<?php echo $flux->getId();?>[]" id="prive<?php echo $flux->getId();?>true" type="checkbox" value="true" <?php if($flux->getPrive()) echo "checked";?> onclick="document.getElementById('idFluxPrive').value='<?php echo $flux->getId();?>'; document.getElementById('navForm').action += '#div<?php echo $flux->getId();?>'; document.getElementById('navForm').submit();">
							<label for="prive<?php echo $flux->getId();?>true"><?php echo $langue->get("PRIVE");?></label>
							<select	id="editFrequenceFlux<?php echo $flux->getId();?>" title="<?php echo htmlspecialchars($langue->get("TITLE_CHANGE_FREQUENCE"));?>" name="editFlux<?php echo $flux->getId();?>" onchange="document.getElementById('idFluxEdit').value=<?php echo $flux->getId();?>;document.getElementById('frequence').value=this.value;document.getElementById('navForm').submit();">
								<option value="0">défaut</option>
								<option value="30"<?php echo $flux->getFequenceMaj() == 30 ? " selected":""?>>1/2h</option>
								<option value="60"<?php echo $flux->getFequenceMaj() == 60 ? " selected":""?>>1h</option>
								<option value="120"<?php echo $flux->getFequenceMaj() == 120 ? " selected":""?>>2h</option>
								<option value="180"<?php echo $flux->getFequenceMaj() == 180 ? " selected":""?>>3h</option>
								<option value="240"<?php echo $flux->getFequenceMaj() == 240 ? " selected":""?>>4h</option>
								<option value="480"<?php echo $flux->getFequenceMaj() == 480 ? " selected":""?>>8h</option>
								<option value="720"<?php echo $flux->getFequenceMaj() == 720 ? " selected":""?>>12h</option>
								<option value="1440"<?php echo $flux->getFequenceMaj() == 1440 ? " selected":""?>>24h</option>
							</select>
							<select	id="editFlux<?php echo $flux->getId();?>" title="<?php echo htmlspecialchars($langue->get("TITLE_CHANGE_CAT"));?>" name="editFlux<?php echo $flux->getId();?>" onchange="document.getElementById('idFluxEdit').value=<?php echo $flux->getId();?>;document.getElementById('newFluxCat').value=this.value;document.getElementById('navForm').submit();">
								<?php echo $listeOption;?>
							</select>
							<span class="fa fa-arrow-down" title="<?php echo htmlspecialchars($langue->get("DESCENDRE") . " " . htmlentities($flux->getTitle()));?>"  onclick="document.getElementById('fluxDown').value='<?php echo $flux->getId();?>'; document.getElementById('navForm').action += '#div<?php echo $flux->getId();?>'; document.getElementById('navForm').submit();"></span>
							<span class="fa fa-arrow-up" title="<?php echo htmlspecialchars($langue->get("MONTER") . " " . htmlentities($flux->getTitle()));?>" onclick="document.getElementById('fluxUp').value='<?php echo $flux->getId();?>'; document.getElementById('navForm').action += '#div<?php echo $flux->getId();?>'; document.getElementById('navForm').submit();"></span>
							<span class="fa fa-times" title="<?php echo htmlspecialchars($langue->get("SUPPRIMER") . " " . htmlentities($flux->getTitle()));?>" onclick="if(confirm('<?php echo htmlspecialchars($langue->get("CONFIRMATION_SUPPRESSION_FLUX"));?>')){document.getElementById('fluxSupprimer').value='<?php echo $flux->getId();?>'; document.getElementById('navForm').action += '#div<?php echo $flux->getId();?>'; document.getElementById('navForm').submit();}"></span>
						</div>
					</div>
					<?php
						}
					?>
				</li>
				<?php
			}
		}
	}
	elseif($idCat > 0)
	{
	?>
		<em><?php echo $langue->get("CATEGORIE_VIDE");?></em>
	<?php 
	}
	?>
	
