<?php
/**
 * 
 * Copyright 2012-2013 Superbaillot
 * This file is part of Aeres.
 *
 *  Aeres is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Aeres is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with Aeres.  If not, see <http://www.gnu.org/licenses/>.
 */
 ?>
		<div class="rss">
			<div class="rssHeader">
				<span class="recherche">
					<input name="recherche" id="recherche" type="text" onkeypress="if (event.keyCode == 13){rechercher();event.preventDefault();}">
					<span class="fa fa-search" title="<?php echo htmlspecialchars($langue->get("RECHERCHER"));?>" onclick="rechercher()"></span>
					<?php require("rechercheForm.php");?>
				</span>
			</div>
		<?php 
			$liste = array();
			$flux = new Rss();
		
			//affichage des items d'une catégorie
			if($idCatAffichee>0)
			{
				$cat = getRssCategorieById($idCatAffichee);
				$liste = getListeItemCat($idCatAffichee, $listeEtat);
		?>
			<div class="rssTitle">
				<?php echo $cat->getTitre();?>
			</div>
			<div class="rssDescription">
			</div><?php	
			}
		
			//affichage de TOUTES les catégories
			elseif($idCatAffichee == -1)
			{
				$liste = getListeItemCat($idCatAffichee, $listeEtat);
			}
		
			//affichage des items d'un flux unique
			elseif($idFlux > 0)
			{
				$flux = getFluxById($idFlux);
				$liste = $flux->getListeItemByEtat($listeEtat);
			?>
			<div class="rssTitle">
				<a href="<?php echo $flux->getLink();?>" title="<?php echo htmlspecialchars($flux->getTitle());?>" target="_blank">
					<?php echo $flux->getTitle();?>
				</a>
				<a href="<?php echo $flux->getUrlFlux();?>" title="<?php echo htmlspecialchars($flux->getTitle());?>" target="_blank">
					<img src="<?php echo CHEMIN_IMAGES_FEED;?>" title="<?php echo htmlspecialchars($langue->get("URL_RSS"));?>" class="iconRss">
				</a><?php 
	
				if(count($flux->getListeImage()) > 0)
				{
					foreach($flux->getListeImage() as $tabImg)
					{
						if($tabImg['link'] != "")
						{
							?>
				<a href="<?php echo $tabImg['link'];?>" title="<?php echo htmlspecialchars($tabImg['title']);?>" target="_blank">
					<img src="<?php echo $tabImg['url'];?>" title="<?php echo htmlspecialchars($tabImg['title']);?>" class="imgRss">
				</a><?php 
						}
						else
						{?>
				<img src="<?php echo $tabImg['url'];?>" title="<?php echo htmlspecialchars($tabImg['title']);?>" class="imgRss"><?php
						}
					}
				}
				?>
			</div>
			<div class="rssDescription">
				<?php echo $flux->getDescription();?>
				<div class="infoDesc">
				<?php echo $langue->get("DATE_DERNIERE_MAJ") . formatDate(strtotime($flux->getDateDerniereMaj()));?>
				</div>
			</div><?php	
	}

	//items d'une recherche
	elseif($recherche != "")
	{
		$liste = getListeItemRecherche($recherche);
		?>
		<div class="rssTitle">
			<?php echo $langue->get("RECHERCHER");?> : 
		</div>
		<div class="rssDescription">
			<?php echo $recherche->getText();?>
		</div><?php
	}
	
	$id = 1;
	require("boutonsOption.php");//FIXME(1, $flux, $idCatAffichee, $listeEtat, $recherche, $inverserTri));

	$listeIdItem = array();	//sert à mettre les id des items affichés dans une variable hidden pour les fonction JS "afficher tous" et "tous cacher"

	if((!$inverserTri && $config->getTriDateCroissante()) || ($inverserTri && !$config->getTriDateCroissante()) )
	{
		usort($liste, "triRssItemParDate");
	}
	else
	{
		usort($liste, "triRssItemParDateInverse");
	}
	
	$debut = 0;
	$fin = count($liste);
	$nbElement = $fin;
	
	if($config->getNbItemAffiche() != 0)
	{
		$debut = (($pageItem - 1) * $config->getNbItemAffiche());
		$fin = $debut + $config->getNbItemAffiche();
	}
	
	for( $i = $debut ; $i < $fin ; $i++)
	{
		if($i >= $nbElement)
		{
			break;
		}
		$item = $liste[$i];
		
		$listeIdItem[] = $item->getIdFlux() . "." . $item->getId();
		$recherche = $recherche != "";
		$modePopup = false;
		$cptLigneBtn = 0;
		require("item.php");
	}
	$id = 2;
	require("boutonsOption.php");//FIXME(2, $flux, $idCatAffichee, $listeEtat, $recherche, $inverserTri));
	
	//affichage des liens vers les pages d'items si besoin
	if($config->getNbItemAffiche() != 0 && $config->getNbItemAffiche() < $nbElement-1)
	{
		$nbPage = ceil($nbElement / $config->getNbItemAffiche());
		echo $langue->get("PAGE") . " : ";

		for ($i = 1 ; $i <= $nbPage ; $i++)
		{
			echo ($i != 1 ? " / " : "");?>
			<span class="pageItem" title="<?php echo htmlspecialchars($langue->get("PAGE") . " $i"); ?>" onclick="<?php echo $idFlux > 0 ? "afficherDetail($idFlux, '" . implode(",", $listeEtat) . "', $i);" : "afficheCat($idCatAffichee, '" . implode(",", $listeEtat) . "', $i " . ($recherche != "" ? ",true" : ",false") . ")";?>">
			<?php 
			if($pageItem != $i)
			{
				echo $i;
			}
			else
			{
				echo "<strong>$i</strong>";
			}
			?>
			</span>
			<?php
		}
	}?>
	<input	type="hidden"
			name="listeIdItem"
			id="listeIdItem"
			value="<?php echo implode($listeIdItem, ",");?>"
	>
</div>
