<?php
/**
 * 
 * Copyright 2012-2013 Superbaillot
 * This file is part of Aeres.
 *
 *  Aeres is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Aeres is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with Aeres.  If not, see <http://www.gnu.org/licenses/>.
 */
 ?>
<!DOCTYPE HTML>
<html>
<?php require("Elements/head.php");?>
	<body>
		<?php 
			require("Elements/header.php");
		?>
		<div id="contenu">
		<?php
			require("Elements/messageInfo.php");
		?>
			<section class="module" id="divConfig">
				<h1>
					<?php echo $GLOBALS["langue"]->get("FOOTER_A_PROPOS");?>
				</h1>
				<div class="cModule">
					<p>
						Aeres est un agrégateur RSS développé par 
						<a href="http://superbaillot.net" title="http://superbaillot.net">Superbaillot</a>
						. Le but d'Aeres était d'avoir un agrégateur RSS sans base de données pour faciliter la sauvegarde. Après plusieurs tentatives non concluantes, je suis arrivé à la solution de sauvegarder chaque flux dans un fichier XML. Pour la sauvegarde, cela nécessite de transférer beaucoup de fichiers, mais comme ils sont dans un répertoire, c'est quand même très facile.
					</p>
					<p>
						Pourquoi ce nom ?<br>En fait, pendant la phase de développement, je l'appelais bêtement aRSS (agrégateur RSS), ce qui n'était pas terrible. Je le prononçais donc "aèressesse". C'était trop long, alors, j'ai coupé la fin et arranger l'orthographe pour aboutir à Aeres. Et j'ai trouvé ça pas si mal, alors je l'ai gardé.
					</p>
					<p>
						Comment cela fonctionne ?
						<br>
						La mise à jour des flux se fait soit manuellement, soit automatiquement. C'est à vous de le choisir dans les paramètres. Si vous choisissez automatiquement, vous pourrez aussi choisir la fréquence de rafraîchissement des flux. Je ne fait aucune vérification sur la durée, si vous voulez, vous pouvez choisir 1 minute, mais je vous déconseille de choisir en dessous de 30 minutes. Pour éviter d'avoir un <em>timeout</em>, je ne recharge les flux que 1 par 1. En fait, pour actualiser tous les flux, le script d'actualisation est lancé pour chaque flux, mais décalé d'une seconde pour ne pas trop surcharger le serveur.
					</p>
					<p>
						Aeres gère l'import et l'export au format OPML
					</p>
					<p>
						Aeres gère aussi les favicons. Le favicon est recherché lors de l'ajout d'un flux, mais par défaut, il n'y a pas de mise à jour lors de l'actualisation automatique des flux pour des raisons d'utilité et de performance. Cela nécessite un appel vers le site en question, donc cela fait perdre du temps, et les favicons ne changent pas souvent. Je me mets tout de même à jour si on actualise un seul flux depuis le détail de ce dernier. Toutefois, j'ai ajouté l'option de mettre à jour les favicons lors d'une actualisation des flux car dans le cas d'un import OPML, je ne vais pas chercher le favicon à chaque flux. Du coup, je n'avais pas les favicons. En actualisant une fois avec cette option d'activée, on peut récupérer les favicons des flux importés. Mais pour le cas général, je déconseille son utilisation.
					</p>
					<p>
						J'ai aussi repris le système de 
						<a href="sebsauvage.net" target="_blank" title="sebsauvage.net">Sebsauvage</a>
						pour son Shaarli qui permet d'ajouter un flux via un marque page présent dans la barre personelle une fois le flux affiché. Donc merci Sebasauvage :)
					</p>
					<p>
						Aeres est distribué sous <a href="http://www.gnu.org/licenses/gpl.html" title="http://www.gnu.org/licenses/gpl.html">license GPLv3</a>.
					</p>
					<p>
						Les icones utilisées pour Aeres proviennent de <a href="http://p.yusukekamiyamane.com" title="http://p.yusukekamiyamane.com">Yusuke Kamiyamane</a>. Les icones sont sous Licence Creative Commons Paternité 3.0. Je le remercie de mettre son travail à disposition.
					</p>
				</div>
			</section>
		</div>
	<?php require("Elements/footer.php");?>
	</body>
</html>
