<?php
/**
 * 
 * Copyright 2012-2013 Superbaillot
 * This file is part of Aeres.
 *
 *  Aeres is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Aeres is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with Aeres.  If not, see <http://www.gnu.org/licenses/>.
 */
 ?>
<!DOCTYPE HTML>
<html>
<?php require("Elements/head.php");?>
	<body>
		<?php require("Elements/header.php");?>
		<div id="divChargement" onclick="cacheMessageChargement()" >
			<span class="loading" title="<?php echo htmlspecialchars($langue->get("CHARGEMENT"));?>"></span>
			<br>
			<?php echo $langue->get("CHARGEMENT");?>
		</div>
		<div id="contenu">
			<?php
				//affichage de l'éventuel message d'erreur ou d'information
				require("Elements/messageInfo.php");
			
				//si on a l'autorisation de voir les flux, on les affiche
				if($GLOBALS["config"]->getVoirFlux() || $GLOBALS["connexion"]->estConnecte())
				{
					require("Elements/formulaireNavigation.php");
				
					$nb = 0;
					foreach($GLOBALS["listeFluxRss"] as $cat)
					{
						$nb += count($cat);
					}
					$nbNonLu = nbItemArchiveTotal(true, false);
					$nbArchive = nbItemArchiveTotal(false, true);
			?>
			<section class="module listeFluxVisible" id="listeFlux">
				<h1>
					<div>
					<span class="fa fa-bars" title="<?php echo htmlspecialchars($langue->get("TITLE_BTN_AFFICHER_LISTE"));?>"  id="btnMasquerListe" onclick="boutonMasquerListe();"></span>
					<?php echo $langue->get("TITRE_MODULE_LISTE");?>
					<span class="nbFlux">(<?php echo htmlspecialchars("$nb " . $langue->get("FLUX"))?>)</span>
					</div>
					<div>
						<div class="archive" id="titreToutArchive" onclick="afficheCat(-1, <?php echo RSS_ARCHIVE;?>, 1)" title="<?php echo htmlspecialchars($langue->get("VOIR_TOUS", $langue->get("ARCHIVE")));?>">
							<?php echo ($nbArchive>0) ? "$nbArchive" : "";?>
						</div>
						<div class="nonLu" id="titreToutNonLu" onclick="afficheCat(-1, <?php echo RSS_NON_LU;?>, 1)" title="<?php echo htmlspecialchars($langue->get("VOIR_TOUS", $langue->get("NON_LU")));?>">
							<?php echo $nbNonLu;?>
						</div>
						<span class="fa fa-refresh" title="<?php echo htmlspecialchars($langue->get("RAFRAICHIR"));?>"  id="btnRafraichir" onclick="boutonRafraichir(<?php echo $GLOBALS["config"]->getRafraichir() ? "true" : "false";?>);"></span>
					
						<span class="fa fa-chevron-down" title="<?php echo htmlspecialchars($langue->get('TITLE_BTN_AFFICHER_LISTE'));?>" onclick="afficherListe()" style="display : none" id="btnAfficherListe"></span>
						<span class="fa fa-chevron-left" title="<?php echo htmlspecialchars($langue->get("TITLE_BTN_CACHER_LISTE"));?>" onclick="cacherListe()" id="btnCacherListe"></span>

					</div>
				</h1>
				<div class="cModule" id="contenuListeFlux">
				<?php 
					$cpt = 0;			//compteur de flux
					$script = "";		//script de mise à jour des flux qui sera complété à chaque flux
					$time = "";			//sert à savoir s'il faut relancer la fonction JS de mise à jour.
										//en effet, à chaque fois que l'utilisateur va cliquer sur le bouton rafraichir, il y aura de plus en plus de rafrachissement (l(es)'ancien(s) plus le rafraichissement nouvellemnt demandé)
										//on va donc faire en sorte que seul le dernier rafraichissement soit pris en compte.
										//on va passer ce paramètre à la fonction de rafraichissement et on va le comparer avec la valeur de l'input hidden ci-dessous.
										//lors d'un rafraichissement, on mettre à jour cet input hidden et donc les anciens appels ne seront plus exécutés.
												
					//affichage de la liste des flux
					$edit = false;
					$fluxAAfficher = getFluxById($idFlux);
					require("Elements/listeFlux.php");
				?>
				</div>
			</section>
		
			<section class="listeItemPetit" id="listeItem">
			
				<div>
					<form method="post" name="formRss" id="formRss">
					<?php 
					//si on doit afficher les items d'un flux ou d'une catégorie
					if($idFlux != 0 || $idCatAffichee != 0)
					{
						$recherche = "";
						require("Elements/rss.php");
					}
					?>
					</form>
				</div>
			</section>
			<script type="text/javascript">
			<?php 

			//ajout du script qui va permetre le rafraichissement des flux
		
			//va servir à savoir quel flux est selectionné pour remettre CSS "normal" lors de la sélection d'un autre flux
			$jsContenu   = "			var idFluxSelected = $idFlux;\n";

			//va servir à savoir quel item est selectionné pour remettre CSS "normal" lors de la sélection d'un autre item
			$jsContenu   .= "			var idItemSelected = 0;\n";

			//défini quel détail est ouvert
			$jsContenu  .= "			var idDivOuvert = " . ($GLOBALS["config"]->getDetailOuvertUnique() ? "0" : "-1") . ";\n";

			//va permettre de compter combien de flux ont été mis à jour depuis le rafraichissement
			$jsContenu .= "			var cpt = 0;\n";
		
			$cpt++;
			//sert à définir combien de flux doivent être mise à jour
			$jsContenu .= "			var cptMax = $cpt;\n";
			$jsContenu .= "			function rafraichir(time)\n";
			$jsContenu .= "			{\n";
			$jsContenu .= "				cpt = 0;\n";
			$jsContenu .= "				rafraichi = true;\n";

			//on change l'icone pour spécifier que le rafraichissement est en cours
			$jsContenu .= "				document.getElementById('btnRafraichir').className = 'fa fa-times';\n";

			//on ajoute le script de mise à jour des flux
			$jsContenu .= $script;

			$jsContenu .= "			}\n";

			$jour = substr($GLOBALS["config"]->getDateDerniereMAJ(), 0,2);
			$mois = substr($GLOBALS["config"]->getDateDerniereMAJ(), 3,2);
			$annee = substr($GLOBALS["config"]->getDateDerniereMAJ(), 6,4);
			$heure = substr($GLOBALS["config"]->getDateDerniereMAJ(), 11,2);
			$min = substr($GLOBALS["config"]->getDateDerniereMAJ(), 14,2);
			$sec = substr($GLOBALS["config"]->getDateDerniereMAJ(), 17,2);

			//si dans les options, on a défini qu'il faille rafraichir automatiquement les flux
			if($GLOBALS["config"]->getRafraichir())
			{
				//on rafraichi les flux à l'affichage de la page. Je laisse un délais de 5s avant de rafraichir les flux
				$attente = 5000;

				//on lance le rafraichissement de tous les flux
				$jsContenu .= "			setTimeout(\"rafraichir($time)\", $attente);\n";
			}
		
			echo $jsContenu;
		
			//chargement des raccourcis claviers
			$listeRAcc = $config->getRaccourciClavier();
		
			foreach($listeRAcc as $racc)
			{
				echo "			" . $racc[1] . ' = "' . strToUpper($racc[0]) .'".charCodeAt(0);'."\n";
			}
			?>
			
				document.onkeydown = applyKey;
			</script>
			<?php
		}
		else
		{
			echo "	<p>" . $langue->get("MSG_FLUX_NON_VISIBLE") . "</p>\n";
		}	?>
		</div>
		<?php
	require("Elements/footer.php");?>
	</body>
</html>
