<?php
/**
 * Ce script rassemble les definitions des paramètres du programme
 *
 * @author Superbaillot
 * 
 * 
 * Copyright 2012-2013 Superbaillot
 * This file is part of Aeres.
 *
 *  Aeres is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Aeres is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with Aeres.  If not, see <http://www.gnu.org/licenses/>.
 */

define("REPERTOIRE_INC", "Inc/");
define("REPERTOIRE_SAUVEGARDE", "Save/");
define("REPERTOIRE_SAUVEGARDE_LANG", REPERTOIRE_INC . "Lang/");
define("FICHIER_LOG_CRON", REPERTOIRE_SAUVEGARDE . "cron.txt");
define("CHEMIN_JS","DOC/js/");
define("CHEMIN_CSS","DOC/css/");

define("REPERTOIRE_VUE", "Inc/Vues/");

define("CHEMIN_IMPORT_OM_AERES", REPERTOIRE_INC . "OM/");
define("CHEMIN_IMPORT_OM_RSS_FLUX", CHEMIN_IMPORT_OM_AERES . "rss.class.php");
define("CHEMIN_IMPORT_OM_RSS_ITEM", CHEMIN_IMPORT_OM_AERES . "rssItem.class.php");
define("CHEMIN_IMPORT_OM_RSS_CATEGORIE", CHEMIN_IMPORT_OM_AERES . "rssCategorie.class.php");
define("CHEMIN_IMPORT_OM_RSS_FILTRE_RECHERCHE", CHEMIN_IMPORT_OM_AERES . "filtreRecherche.class.php");
define("CHEMIN_IMPORT_OM_CONFIGURATION_AERES", CHEMIN_IMPORT_OM_AERES . "configurationAeres.class.php");

require_once(REPERTOIRE_INC . "aeresInc.php");

require_once(CHEMIN_IMPORT_OM_RSS_CATEGORIE);
require_once(CHEMIN_IMPORT_OM_RSS_FLUX);
require_once(CHEMIN_IMPORT_OM_RSS_ITEM);
require_once(CHEMIN_IMPORT_OM_RSS_FILTRE_RECHERCHE);
require_once(CHEMIN_IMPORT_OM_CONFIGURATION);
require_once(CHEMIN_IMPORT_OM_CONFIGURATION_AERES);
require_once(CHEMIN_IMPORT_OM_LOGO);
require_once(CHEMIN_IMPORT_OM_FAVICON);
require_once(CHEMIN_IMPORT_OM_CONNEXION);
require_once(CHEMIN_IMPORT_OM_LANGUE);

//fichier de configuration
define("FICHIER_CONFIG", REPERTOIRE_SAUVEGARDE . "config.xml");							//fichier de configuration

define("CHEMIN_JS_AERES", CHEMIN_JS . "aeres.js");
define("CHEMIN_CSS_AERES", CHEMIN_CSS . "aeres.css");
define("CHEMIN_FAVICON", REPERTOIRE_SAUVEGARDE . "favicon/");
define("CHEMIN_DOSSIER_LOGO", REPERTOIRE_SAUVEGARDE);
define("CHEMIN_FLUX", REPERTOIRE_SAUVEGARDE . "flux/");

define("NOM_FICHIER_FLUX", CHEMIN_FLUX . "flux");
define("NOM_FICHIER_CATEGORIE", REPERTOIRE_SAUVEGARDE . "listeCat.xml");

define("PAGE_LISTE", 1);
define("PAGE_POPUP_AJOUT_RSS", 2);
define("PAGE_OPTION_RSS", 3);
define("PAGE_CONFIG", 4);
define("PAGE_DETAIL_FLUX", 5);
define("PAGE_ACTUALISER_FLUX", 6);
define("PAGE_EXPORT", 7);
define("PAGE_SAUVEGARDE", 8);
define("PAGE_APROPOS", 9);
define("PAGE_RECHERCHE", 10);
define("PAGE_DETAIL_ITEM", 11);
define("MAX_PAGE_RSS", 11);

define("RSS_NON_LU",0);
define("RSS_ARCHIVE",1);
define("RSS_LU",2);
define("MAX_ETAT_RSS", 2);

define("ACCESSIBLE",0);
define("RSS_NON_ACCESSIBLE",1);

define("CARACTERE_ET","____");

define("URL_AERES", CHEMIN_SERVEUR . "/site/mesContributions-aeres.php");				//url vers la présentation de Aeres
define("URL_AERES_ARCHIVE", CHEMIN_SERVEUR . "/site/DOC/Divers/Aeres/Aeres.zip");			//url vers le téléchargement d'Aeres
define("URL_CHECK_MAJ", CHEMIN_SERVEUR . "/site/checkMaj.php?projet=aeres");			//url vers la vérificatin de nouvelle version

$config = new ConfigurationAeres();
$config->setFichierConf(FICHIER_CONFIG);
$config->charger();

$langue = new Langue(REPERTOIRE_SAUVEGARDE_LANG, $config->getLangue());

define("NOM_SESSION_RSS", "connexionSuperbaillot" . $config->getPseudo());

?>
